// LiftControlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LiftControl.h"

#include "MySocket.h"
#include "LiftControlDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLiftControlDlg dialog

CLiftControlDlg* theDialog;

CLiftControlDlg::CLiftControlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLiftControlDlg::IDD, pParent)
{
	theDialog=this;
	//{{AFX_DATA_INIT(CLiftControlDlg)
	m_ServerAddress = _T("127.0.0.1");
	m_ServerPort = 5438;
	m_Command = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CLiftControlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLiftControlDlg)
	DDX_Control(pDX, IDC_SERVERDATA, m_ServerData);
	DDX_Text(pDX, IDC_SERVERADDRESS, m_ServerAddress);
	DDX_Text(pDX, IDC_SERVERPORT, m_ServerPort);
	DDX_Text(pDX, IDC_COMMAND, m_Command);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLiftControlDlg, CDialog)
	//{{AFX_MSG_MAP(CLiftControlDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_BN_CLICKED(IDC_SEND, OnSend)
	ON_EN_CHANGE(IDC_COMMAND, OnChangeCommand)
	ON_BN_CLICKED(IDC_OPENALL, OnOpenall)
	ON_BN_CLICKED(IDC_CLOSEALL, OnCloseall)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLiftControlDlg message handlers

BOOL CLiftControlDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_ServerData.InsertColumn(0,"Server->Klient",LVCFMT_LEFT,200);
	m_ServerData.InsertColumn(1,"Klient->Server (odpov)",LVCFMT_LEFT,200);

	m_nShafts=0;
	m_ShaftPositions=NULL;
	m_ShaftRequests=NULL;
	m_ShaftDirections=NULL;
	m_DoorsOpen=NULL;
	m_DoorsBlocked=NULL;
	m_ShaftSpeed=NULL;

	m_MaxSpeed=1;

	m_hThread=NULL;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLiftControlDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLiftControlDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CLiftControlDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	//CDialog::OnOK();
}

void CLiftControlDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

// tato funkce je hlavni cast programu, zpracovana pozadavky, reaguje na ne, odpovida serveru
void CLiftControlDlg::ProcessMessageFromServerWorker()
{
	CString msg=m_MessageFromServer;
	int a=m_ServerData.InsertItem(0,msg);

	int f=msg.Find(" ");

	CString mainCommand;
	CString parameters; // parametry
	CArray<CString,CString&> params; // rozdelene parametry - pres mezery

	// zinicializuje prommne, rozdeli parametry
	if (f!=-1)
	{
		mainCommand=msg.Left(f);

		parameters=msg.Mid(f+1);

		int a=0;
		while ((f=parameters.Find(" ",a))!=-1)
		{
			params.Add(parameters.Mid(a,f-a));
			a=f+1;
		}
		params.Add(parameters.Mid(a));
	}
	else
		mainCommand=msg;

	CString reply;

	if (mainCommand=="levels")
	{
		m_nLevels=atoi(params[0]);
	}

	if (mainCommand=="maxdev")
	{
		m_MaxDev=atoi(params[0]);
	}

	if (mainCommand=="shafts")
	{
		m_nShafts=atoi(params[0]);
		
		// smazani puvodni dat (jestli nejake jsou)
		if (m_ShaftPositions) delete m_ShaftPositions;
		if (m_ShaftRequests) delete m_ShaftRequests;
		if (m_ShaftDirections) delete m_ShaftDirections;
		if (m_DoorsOpen) delete m_DoorsOpen;
		if (m_DoorsBlocked) delete m_DoorsBlocked;
		if (m_ShaftSpeed) delete m_ShaftSpeed;

		// inicializace
		m_ShaftPositions=new int[m_nShafts];
		m_ShaftRequests=new int[m_nShafts];
		m_ShaftDirections=new int[m_nShafts];
		m_DoorsOpen=new int[m_nShafts];
		m_DoorsBlocked=new int[m_nShafts];
		m_ShaftSpeed=new int[m_nShafts];

		for (int i=0;i<m_nShafts;i++)
		{
			m_ShaftDirections[i]=0; // nikam nejede
			m_ShaftRequests[i]=-1; // zadny pozadavek
			m_ShaftPositions[i]=0; // jsou v prizemi
			m_DoorsBlocked[i]=0;
			m_ShaftSpeed[i]=0;

			// otevreme dvere (pro jistotu :-)
			CString tmp;
			tmp.Format("open %d",i);
			SendMessageToServer(tmp);
			m_DoorsOpen[i]=1;

			// nastavim napis v kabina
			tmp.Format("shaftinfo %d CEKAM",i);
			SendMessageToServer(tmp);
		}
	}

	if (mainCommand=="maxspeed")
	{
		m_MaxSpeed=atoi(params[0]);
	}

	if (mainCommand=="speed")
	{
		int shaftindex=atoi(params[0]);

		m_ShaftSpeed[shaftindex]=atoi(params[1]);

		if (!m_ShaftSpeed[shaftindex])
		{
			if (!m_DoorsOpen[atoi(params[0])])
			{
				reply.Format("open %s",params[0]);
			}
		}
	}

	if (mainCommand=="maxaccel")
	{
		m_MaxAcceleration=atoi(params[0]);
	}

	if (mainCommand=="meter")
	{
		int liftindex=atoi(params[0]);
		int pos=atoi(params[1]);
	}

	if (mainCommand=="blocked")
	{
		reply.Format("unblock %s",params[0]);
	}

	if ((mainCommand=="levelbuttonup")||(mainCommand=="levelbuttondn"))
	{
		// vybere nejblizsi vytah
		int starti=0;
		int nearest=0;
		int requested=atoi(params[0]);
		int distance=abs(requested-m_ShaftPositions[0]);

		while ((m_ShaftRequests[starti]!=-1)||(m_DoorsBlocked[starti]))
		{
			nearest++;
			starti++;
			distance=abs(requested-m_ShaftPositions[starti]);
		}

		for (int i=starti+1;i<m_nShafts;i++)
		{
			if ((m_ShaftRequests[i]!=-1)||(m_DoorsBlocked[i])) continue; // vytah je zaneprazdnen

			int test=abs(requested-m_ShaftPositions[i]); // zkousena vzdalenost
			if (test<distance)
			{
				distance=test;
				nearest=i;
			}
		}

		if (distance) // poue pokud uz tam vytah neni
		{
			if (m_DoorsOpen[nearest])
			{
				CString tmp;
				tmp.Format("close %d",nearest);
				SendMessageToServer(tmp);
			}
			else
			{
				CString tmp;
				tmp.Format("indion %d %d",nearest,requested);
				SendMessageToServer(tmp);

				m_ShaftDirections[nearest]=((requested-m_ShaftPositions[nearest]>0)?-1:1);
				for (i=m_ShaftPositions[nearest];i!=(requested-m_ShaftDirections[nearest]);i-=m_ShaftDirections[nearest])
				{
					if (m_ShaftDirections[nearest]==1)
						tmp.Format("indidnon %d",i);
					else
						tmp.Format("indiupon %d",i);

					SendMessageToServer(tmp);
				}

				m_ShaftRequests[nearest]=requested;


				// nastavi popisek
				tmp.Format("shaftinfo %d %d.",nearest,requested);
				SendMessageToServer(tmp);

				reply.Format("speed %d %d",nearest,m_MaxAcceleration*m_ShaftDirections[nearest]);
			}
		}
	}

	if (mainCommand=="cabinbutton")
	{
		// vybere nejblizsi vytah
		int starti=0;
		int nearest=0;
		int requested=atoi(params[1]);
		int distance=abs(requested-m_ShaftPositions[0]);

		while ((m_ShaftRequests[starti]!=-1)||(m_DoorsBlocked[starti]))
		{
			nearest++;
			starti++;
			distance=abs(requested-m_ShaftPositions[starti]);
		}

		for (int i=starti+1;i<m_nShafts;i++)
		{
			if ((m_ShaftRequests[i]!=-1)||(m_DoorsBlocked[i])) continue; // vytah je zaneprazdnen

			int test=abs(requested-m_ShaftPositions[i]); // zkousena vzdalenost
			if (test<distance)
			{
				distance=test;
				nearest=i;
			}
		}

		if (distance) // poue pokud uz tam vytah neni
		{
			CString tmp;
			tmp.Format("indion %d %d",nearest,requested);
			SendMessageToServer(tmp);

			m_ShaftDirections[nearest]=((requested-m_ShaftPositions[nearest]>0)?-1:1);
			for (i=m_ShaftPositions[nearest];i!=(requested-m_ShaftDirections[nearest]);i-=m_ShaftDirections[nearest])
			{
				if (m_ShaftDirections[nearest]==1)
					tmp.Format("indidnon %d",i);
				else
					tmp.Format("indiupon %d",i);

				SendMessageToServer(tmp);
			}

			m_ShaftRequests[nearest]=requested;

			tmp.Format("close %d",nearest);
			SendMessageToServer(tmp);

			// nastavi popisek
			tmp.Format("shaftinfo %d %d.",nearest,requested);
			SendMessageToServer(tmp);

			reply.Format("speed %d %d",nearest,m_MaxAcceleration*m_ShaftDirections[nearest]);
		}
	}

	if (mainCommand=="opened")
	{
		m_DoorsOpen[atoi(params[0])]=1;
	}
	if (mainCommand=="closed")
	{
		m_DoorsOpen[atoi(params[0])]=0;
	}

	if (mainCommand=="levelheight")
	{
		m_LevelHeight=atoi(params[0]);
	}

	if (mainCommand=="level")
	{
		int shaftindex=atoi(params[0]);
		int currentlevel=atoi(params[1]);

		m_ShaftPositions[shaftindex]=currentlevel;

		if ( ((m_ShaftRequests[shaftindex]<=currentlevel)&&(m_ShaftDirections[shaftindex]==-1))||
			((m_ShaftRequests[shaftindex]>=currentlevel)&&(m_ShaftDirections[shaftindex]==1))
			)
		{
			/*for (int i=0;i<m_nLevels;i++)
			{
				CString tmp;
				if (m_ShaftDirections[shaftindex]==1)
					tmp.Format("indidnoff %d",i);
				else
					tmp.Format("indiupoff %d",i);
				SendMessageToServer(tmp);
			}*/

			CString tmp;
			tmp.Format("indioff %d %d",shaftindex,m_ShaftRequests[shaftindex]);
			SendMessageToServer(tmp);

			reply.Format("floor %d %d\r\nspeed %d 0",shaftindex,currentlevel,shaftindex); // skoci na presnou pozici (kdyz je blizko :-)
			m_ShaftRequests[shaftindex]=-1;
			m_ShaftDirections[shaftindex]=0;

			tmp.Format("shaftinfo %d CEKAM",shaftindex);
			SendMessageToServer(tmp);

			tmp.Format("open %d",shaftindex);
			SendMessageToServer(tmp);

		}
		else
		{
			if (m_ShaftRequests[shaftindex]!=-1)
			{
				// UPRAVA RYCHLOSTI VYTAHU - vyuzivani akcelerace, vzdalenosti mezi podlazima atd.
				int destlevel=m_ShaftRequests[shaftindex]; // cilove podlazi
				int distance=abs(m_ShaftRequests[shaftindex]-currentlevel)*m_LevelHeight; // vzdalenost v mm
				int currspeed=m_ShaftSpeed[shaftindex];

				int remainingtime=distance/abs(currspeed);
				if (m_MaxAcceleration*remainingtime<abs(currspeed))
				{
					reply.Format("speed %d %d",shaftindex,m_MaxAcceleration*abs(currspeed)/currspeed); // musime brzdit
				}
				else
				{
					reply.Format("speed %d %d",shaftindex,m_MaxSpeed*abs(currspeed)/currspeed); // muzeme zrychlovat
				}
			}
		}
	}

	if (reply.GetLength())
	{
		SendMessageToServer(reply);
		m_ServerData.SetItemText(a,1,reply);
	}

	int x=5;
}

void CLiftControlDlg::ProcessMessageFromServer()
{
	::SendMessage(theDialog->m_hWnd,WM_USER+3,0,0);
}

void CLiftControlDlg::SendMessageToServer(CString msg)
{
	if (msg.Right(2)!="\r\n") msg+="\r\n";
	m_Socket.Send((void*)(LPCTSTR)msg,msg.GetLength());
}

void CLiftControlDlg::OnConnect() 
{
	UpdateData(TRUE);

	try
	{
		// pripojeni k serveru - pres tridu MySocket
		theDialog=this;
		m_Socket.Create();
		m_Socket.Connect(m_ServerAddress,m_ServerPort);

		// tlacitka connect a disconnect - nastaveni spravnych stavu enbaled/disabled
		::PostMessage(theDialog->m_hWnd,WM_USER+1,0,0);

		// zazadani o vsechny dulezite parametry
		SendMessageToServer("shafts");
		SendMessageToServer("levels");
		SendMessageToServer("param");
	}
	catch (...)
	{
		MessageBox("Chyba pi pipojovn, zkuste to prosm jet jednou nebo restartujte program","Chyba",MB_OK|MB_ICONEXCLAMATION);
	}
}

void CLiftControlDlg::OnDisconnect() 
{
	// odpojeni
	try
	{
		m_Socket.ShutDown();
		m_Socket.Close();
	}
	catch (...)
	{
	}

	// tlacitka connect a disconnect - nastaveni spravnych stavu enbaled/disabled
	::PostMessage(theDialog->m_hWnd,WM_USER+2,0,0);
}

LRESULT CLiftControlDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	switch (message)
	{
	case WM_USER+1:
		{
			GetDlgItem(IDC_DISCONNECT)->EnableWindow(TRUE);
			GetDlgItem(IDC_CONNECT)->EnableWindow(FALSE);
			break;
		}
	case WM_USER+2:
		{
			GetDlgItem(IDC_DISCONNECT)->EnableWindow(FALSE);
			GetDlgItem(IDC_CONNECT)->EnableWindow(TRUE);
			break;
		}
	case WM_USER+3:
		{
			// zpracovani zpravy ze serveru - implementovani pomoci WindowProc kvuli problum s threadingem
			ProcessMessageFromServerWorker();
			break;
		}
	}
	
	return CDialog::WindowProc(message, wParam, lParam);
}

void CLiftControlDlg::OnSend() 
{
	UpdateData(TRUE);
	SendMessageToServer(m_Command);
}

void CLiftControlDlg::OnChangeCommand() 
{
	CButton* btn=(CButton*)GetDlgItem(IDC_SEND);
	btn->SetButtonStyle(btn->GetButtonStyle()|BS_DEFPUSHBUTTON);
}

void CLiftControlDlg::OnOpenall() 
{
	for (int i=0;i<m_nShafts;i++)
	{
		CString tmp;
		tmp.Format("open %d",i);
		SendMessageToServer(tmp);
	}
}

void CLiftControlDlg::OnCloseall() 
{
	for (int i=0;i<m_nShafts;i++)
	{
		CString tmp;
		tmp.Format("close %d",i);
		SendMessageToServer(tmp);
	}
}
